/*******************************************************************************
 * @file    LED.h
 * @author  King
 * @version V1.00
 * @date    27-Nov-2021
 * @brief   ......
*******************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __LED_H__
#define __LED_H__


#ifdef __cplusplus
extern "C" {
#endif


#undef  EXTERN


#ifdef  __LED_C__
#define EXTERN
#else
#define EXTERN extern
#endif


/* Includes ------------------------------------------------------------------*/
#include "config.h"


/* Exported constants --------------------------------------------------------*/
#define LED_NUMBER  4

#define LED1_GPIO   GPIOC
#define LED1_PIN    FL_GPIO_PIN_1

#define LED2_GPIO   GPIOC
#define LED2_PIN    FL_GPIO_PIN_0

#define LED3_GPIO   GPIOD
#define LED3_PIN    FL_GPIO_PIN_12

#define LED4_GPIO   GPIOB
#define LED4_PIN    FL_GPIO_PIN_15


/* Exported types ------------------------------------------------------------*/
typedef struct
{
    GPIO_Type *GPIOx;
    uint32_t   pin;
} LED_TypeDef;


/* Exported macro ------------------------------------------------------------*/


/* Exported functions --------------------------------------------------------*/
EXTERN void LED_Init(void);
EXTERN void LED_Toggle(void);
EXTERN void LED_SHELL_Handler(uint8_t Enable);


#ifdef __cplusplus
}
#endif


#endif


/******************* (C) COPYRIGHT 2021 *************************END OF FILE***/

