/*******************************************************************************
 * @file    DAC.c
 * @author  King
 * @version V1.00
 * @date    27-Nov-2021
 * @brief   ......
*******************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#define __DAC_C__


/* Includes ------------------------------------------------------------------*/
#include "DAC.h"


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/


/* Exported variables --------------------------------------------------------*/
/* Exported function prototypes ----------------------------------------------*/


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void DAC_Configure(void)
{
    FL_GPIO_InitTypeDef GPIO_InitStruct;
    FL_DAC_InitTypeDef  DAC_InitStruct;

    FL_GPIO_StructInit(&GPIO_InitStruct);
    GPIO_InitStruct.pin        = FL_GPIO_PIN_5;
    GPIO_InitStruct.mode       = FL_GPIO_MODE_ANALOG;
    GPIO_InitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;
    FL_GPIO_Init(GPIOC, &GPIO_InitStruct);

    FL_DAC_StructInit(&DAC_InitStruct);
    DAC_InitStruct.sampleHoldMode = FL_DISABLE;
    DAC_InitStruct.sampleTime     = 0xFF;
    DAC_InitStruct.holdTime       = 0x00;
    DAC_InitStruct.triggerMode    = FL_DISABLE;
    DAC_InitStruct.triggerSource  = FL_DAC_TRGI_SOFTWARE;
    DAC_InitStruct.bufferMode     = FL_DISABLE;
    DAC_InitStruct.switchMode     = FL_ENABLE;
    FL_DAC_Init(DAC, &DAC_InitStruct);

    FL_DAC_Enable(DAC);
    FL_DAC_WriteData(DAC, 2047);

    TASK_Append(TASK_ID_DAC, DAC_Handler, 1);
}


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void DAC_Handler(void)
{
    uint16_t WaveData[1284] =
    {
        2047,2147,2248,2347,2446,2545,2641,2737,2831,2922,
        3012,3100,3185,3267,3346,3422,3495,3564,3630,3692,
        3749,3803,3853,3898,3939,3975,4006,4033,4055,4072,
        4085,4092,4095,4092,4085,4072,4055,4033,4006,3975,
        3939,3898,3853,3803,3749,3692,3630,3564,3495,3422,
        3346,3267,3185,3100,3012,2922,2831,2737,2641,2545,
        2446,2347,2248,2147,2047,1947,1846,1747,1648,1549,
        1453,1357,1263,1172,1082, 994, 909, 827, 748, 672,
         599, 530, 464, 402, 345, 291, 241, 196, 155, 119,
          88,  61,  39,  22,   9,   2,   0,   2,   9,  22,
          39,  61,  88, 119, 155, 196, 241, 291, 345, 402,
         464, 530, 599, 672, 748, 827, 909, 994,1082,1172,
        1263,1357,1453,1549,1648,1747,1846,1947
    };

    static uint8_t WaveIndex = 0;

    FL_DAC_WriteData(DAC, WaveData[WaveIndex]);

    WaveIndex = (WaveIndex + 1) % 128;
}


/******************* (C) COPYRIGHT 2021 *************************END OF FILE***/

