/*******************************************************************************
 * @file    KEY.c
 * @author  King
 * @version V1.00
 * @date    27-Nov-2021
 * @brief   ......
*******************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#define __KEY_C__


/* Includes ------------------------------------------------------------------*/
#include "KEY.h"


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/


/* Private variables ---------------------------------------------------------*/
KEY_TypeDef KEY[KEY_NUMBER] =
{
    {KEY1_GPIO, KEY1_PIN},
    {KEY2_GPIO, KEY2_PIN},
    {KEY3_GPIO, KEY3_PIN},
    {KEY4_GPIO, KEY4_PIN},
};


/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/


/* Exported variables --------------------------------------------------------*/
/* Exported function prototypes ----------------------------------------------*/


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void KEY_Init(void)
{
    FL_GPIO_InitTypeDef GPIO_InitStruct;

    for(uint8_t i = 0; i < KEY_NUMBER; i++)
    {
        FL_GPIO_StructInit(&GPIO_InitStruct);
        GPIO_InitStruct.pin  = KEY[i].pin;
        GPIO_InitStruct.mode = FL_GPIO_MODE_INPUT;
        GPIO_InitStruct.pull = FL_ENABLE;
        FL_GPIO_Init(KEY[i].GPIOx, &GPIO_InitStruct);
    }

    TASK_Append(TASK_ID_KEY, KEY_Scan, 10);
}


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void KEY_SubScan(uint8_t *State, uint8_t *Count, uint32_t Value, char *Name)
{
    if(*State == 0)
    {
        if(Value == 0)
        {
            *Count += 1;

            if(*Count > 5)
            {
                *Count = 0; *State = 1;

                printf("\r\n%s Pressed...", Name);
            }
        }
        else
        {
            *Count = 0;
        }
    }
    else
    {
        if(Value != 0)
        {
            *Count += 1;

            if(*Count > 5)
            {
                *Count = 0; *State = 0;

                printf("\r\n%s Release\r\n", Name);
            }
        }
        else
        {
            *Count = 0;
        }
    }
}


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void KEY_Scan(void)
{
    static uint8_t KEY1_State = 0, KEY1_Count = 0;
    static uint8_t KEY2_State = 0, KEY2_Count = 0;
    static uint8_t KEY3_State = 0, KEY3_Count = 0;
    static uint8_t KEY4_State = 0, KEY4_Count = 0;

    KEY_SubScan(&KEY1_State, &KEY1_Count,
                FL_GPIO_GetInputPin(KEY[0].GPIOx, KEY[0].pin),
                "KEY1");

    KEY_SubScan(&KEY2_State, &KEY2_Count,
                FL_GPIO_GetInputPin(KEY[1].GPIOx, KEY[1].pin),
                "KEY2");

    KEY_SubScan(&KEY3_State, &KEY3_Count,
                FL_GPIO_GetInputPin(KEY[2].GPIOx, KEY[2].pin),
                "KEY3");

    KEY_SubScan(&KEY4_State, &KEY4_Count,
                FL_GPIO_GetInputPin(KEY[3].GPIOx, KEY[3].pin),
                "KEY4");
}


/******************* (C) COPYRIGHT 2021 *************************END OF FILE***/

