/*******************************************************************************
 * @file    LED.c
 * @author  King
 * @version V1.00
 * @date    27-Nov-2021
 * @brief   ......
*******************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#define __LED_C__


/* Includes ------------------------------------------------------------------*/
#include "LED.h"


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/


/* Private variables ---------------------------------------------------------*/
LED_TypeDef LED[LED_NUMBER] =
{
    {LED1_GPIO, LED1_PIN},
    {LED2_GPIO, LED2_PIN},
    {LED3_GPIO, LED3_PIN},
    {LED4_GPIO, LED4_PIN},
};

uint8_t LED_ToggleEnable = 1;


/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/


/* Exported variables --------------------------------------------------------*/
/* Exported function prototypes ----------------------------------------------*/


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void LED_Init(void)
{
    FL_GPIO_InitTypeDef GPIO_InitStruct;

    for(uint8_t i = 0; i < LED_NUMBER; i++)
    {
        FL_GPIO_StructInit(&GPIO_InitStruct);
        GPIO_InitStruct.pin        = LED[i].pin;
        GPIO_InitStruct.mode       = FL_GPIO_MODE_OUTPUT;
        GPIO_InitStruct.outputType = FL_GPIO_OUTPUT_PUSHPULL;
        FL_GPIO_Init(LED[i].GPIOx, &GPIO_InitStruct);

        FL_GPIO_SetOutputPin(LED[i].GPIOx, LED[i].pin);
    }


    TASK_Append(TASK_ID_LED, LED_Toggle, 250);
}


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void LED_Toggle(void)
{
    if(LED_ToggleEnable)
    {
        FL_GPIO_ToggleOutputPin(LED[3].GPIOx, LED[3].pin);
    }
}


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void LED_SHELL_Handler(uint8_t Enable)
{
    LED_ToggleEnable = Enable;
}


/******************* (C) COPYRIGHT 2021 *************************END OF FILE***/

