/*******************************************************************************
 * @file    LPTIMxx.c
 * @author  King
 * @version V1.00
 * @date    27-Nov-2021
 * @brief   ......
*******************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#define __LPTIMxx_C__


/* Includes ------------------------------------------------------------------*/
#include "LPTIMxx.h"


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/


/* Private variables ---------------------------------------------------------*/
volatile uint32_t LPTIM32_Tick = 0;


/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/


/* Exported variables --------------------------------------------------------*/
/* Exported function prototypes ----------------------------------------------*/


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void LPTIM32_Init(void)
{
    FL_LPTIM32_InitTypeDef LPTIM32_InitStruct;

    FL_LPTIM32_StructInit(&LPTIM32_InitStruct);
    LPTIM32_InitStruct.clockSource          = FL_CMU_LPTIM32_CLK_SOURCE_APBCLK;
    LPTIM32_InitStruct.mode                 = FL_LPTIM32_OPERATION_MODE_NORMAL;
    LPTIM32_InitStruct.prescalerClockSource = FL_LPTIM32_CLK_SOURCE_INTERNAL;
    LPTIM32_InitStruct.prescaler            = FL_LPTIM32_PSC_DIV8;
    LPTIM32_InitStruct.autoReload           = 1000 - 1;
    LPTIM32_InitStruct.onePulseMode         = FL_LPTIM32_ONE_PULSE_MODE_CONTINUOUS;
    LPTIM32_InitStruct.triggerEdge          = FL_LPTIM32_ETR_TRIGGER_EDGE_RISING;
    LPTIM32_InitStruct.countEdge            = FL_LPTIM32_ETR_COUNT_EDGE_RISING;
    FL_LPTIM32_Init(LPTIM32, &LPTIM32_InitStruct);

    FL_LPTIM32_ClearFlag_Update(LPTIM32);
    FL_LPTIM32_EnableIT_Update(LPTIM32);

    NVIC_DisableIRQ(LPTIMx_IRQn);
    NVIC_SetPriority(LPTIMx_IRQn, 2);
    NVIC_EnableIRQ(LPTIMx_IRQn);

    FL_LPTIM32_Enable(LPTIM32);
}


/*******************************************************************************
 * @brief       
 * @param       
 * @retval      
 * @attention   
*******************************************************************************/
void LPTIM_IRQHandler(void)
{
    if(FL_LPTIM32_IsEnabledIT_Update(LPTIM32) &&
       FL_LPTIM32_IsActiveFlag_Update(LPTIM32) )
    {
        LPTIM32_Tick++;
        TASK_TimeSlice(LPTIM32_Tick);

        FL_LPTIM32_ClearFlag_Update(LPTIM32);
    }
}


/******************* (C) COPYRIGHT 2021 *************************END OF FILE***/

